#include <iostream>

using namespace std;

int main()
{
    int sirinaVodopada, visinaVodopada, protokUKantici, pocetakStena= -1;
    cin >> visinaVodopada;
    cin >> sirinaVodopada;

    short vodopadStene[sirinaVodopada][visinaVodopada], vodopadProtok[sirinaVodopada][visinaVodopada];

    for(int i = 0; i < visinaVodopada; i++)
    {
        for(int j = 0; j < sirinaVodopada; j++)
        {
            cin >> vodopadStene[j][i];
        }
    }

    for(int i = 0; i < visinaVodopada; i++)
    {
        protokUKantici = 0;
        pocetakStena = -1;
        for(int j = 0; j < sirinaVodopada; j++)
        {
            if(i == 0)
            {
                if(vodopadStene[j][i] == 0)
                {
                    if(pocetakStena == -1)
                    {
                        pocetakStena = j;
                        protokUKantici += 1;
                        vodopadProtok[j][i] = 0;
                        if(j == sirinaVodopada -1)
                        {
                            vodopadProtok[pocetakStena-1][i] += protokUKantici;
                            protokUKantici = 0;
                            pocetakStena = 0;
                        }
                    }
                    else
                    {
                        protokUKantici += 1;
                        vodopadProtok[j][i] = 0;
                        if(j == sirinaVodopada -1)
                        {
                            vodopadProtok[pocetakStena-1][i] += protokUKantici;
                            protokUKantici = 0;
                            pocetakStena = 0;

                        }
                    }
                }
                else if(vodopadStene[j-1][i] == 0)
                {
                    if(pocetakStena == 0)
                    {
                        vodopadProtok[j][i] = 1 + protokUKantici;
                        protokUKantici = 0;
                        pocetakStena = -1;
                    }
                    else
                    {
                        vodopadProtok[pocetakStena-1][i] += protokUKantici/2 + protokUKantici%2;
                        vodopadProtok[j][i] = protokUKantici/2 + 1;
                        protokUKantici = 0;
                        pocetakStena = -1;
                    }
                }
                else
                {
                    vodopadProtok[j][i] = 1;
                }

            }
            else if(i % 2 == 1)
            {
                if(vodopadStene[j][i] == 0)
                {
                    if(pocetakStena == -1)
                    {
                        vodopadProtok[j][i] = 0;
                        protokUKantici += vodopadProtok[j][i-1];
                        pocetakStena = j;
                        if(j == sirinaVodopada -1)
                        {
                            vodopadProtok[pocetakStena-1][i] += protokUKantici;
                            protokUKantici = 0;
                            pocetakStena = 0;

                        }

                    }
                    else
                    {
                        vodopadProtok[j][i] = 0;
                        protokUKantici += vodopadProtok[j][i-1];
                        if(j == sirinaVodopada -1)
                        {
                            vodopadProtok[pocetakStena-1][i] += protokUKantici;
                            protokUKantici = 0;
                            pocetakStena = 0;
                        }
                    }
                }
                else if(vodopadProtok[j-1][i] == 0)
                {
                    if(pocetakStena == 0)
                    {
                        vodopadProtok[j][i] = vodopadProtok[j][i-1] + protokUKantici;
                        protokUKantici = 0;
                        pocetakStena = -1;
                    }
                    else
                    {
                        vodopadProtok[j][i] = vodopadProtok[j][i-1] + protokUKantici/2 + protokUKantici%2;
                        vodopadProtok[pocetakStena -1][i] += protokUKantici/2;
                        protokUKantici = 0;
                        pocetakStena = -1;
                    }
                }
                else
                {
                    vodopadProtok[j][i] = vodopadProtok[j][i-1];
                }
            }
            else if(i % 2 == 0)
            {
                if(vodopadStene[j][i] == 0)
                {
                    if(pocetakStena == -1)
                    {
                        vodopadProtok[j][i] = 0;
                        protokUKantici += vodopadProtok[j][i-1];
                        pocetakStena = j;
                        if(j == sirinaVodopada -1)
                        {
                            vodopadProtok[pocetakStena-1][i] += protokUKantici;
                            protokUKantici = 0;
                            pocetakStena = 0;

                        }

                    }
                    else
                    {
                        vodopadProtok[j][i] = 0;
                        protokUKantici += vodopadProtok[j][i-1];
                        if(j == sirinaVodopada -1)
                        {
                            vodopadProtok[pocetakStena-1][i] += protokUKantici;
                            protokUKantici = 0;
                            pocetakStena = 0;
                        }
                    }
                }
                else if(vodopadProtok[j-1][i] == 0)
                {
                    if(pocetakStena == 0)
                    {
                        vodopadProtok[j][i] = vodopadProtok[j][i-1] + protokUKantici;
                        protokUKantici = 0;
                        pocetakStena = -1;
                    }
                    else
                    {
                        vodopadProtok[j][i] = vodopadProtok[j][i-1] + protokUKantici/2;
                        vodopadProtok[pocetakStena -1][i] += protokUKantici/2 + protokUKantici%2;
                        protokUKantici = 0;
                        pocetakStena = -1;
                    }
                }
                else
                {
                    vodopadProtok[j][i] = vodopadProtok[j][i-1];
                }
            }

        }
    }
    for(int i = 0; i < sirinaVodopada; i++)
    {
        cout << vodopadProtok[i][visinaVodopada-1] << " ";
    }



    return 0;
}